\environment entorn

<%
# Funció per a implementar el signe dels nombres: +n o -n segons si n és positiu o negatiu
# https://stackoverflow.com/a/63552871
class Numeric
  def to_ss   # to signed string
    self.negative? ? self.to_s : "+#{self.to_s}"
  end
end
%>

\starttext

\startsubject[title={Sistemes d'equacions lineals $2\times 2$}]

\startsubsubject[title={Preguntes}]

<%

exercicis = Hash.new

%>

<%# Exercici 1 %>
<%
exercicis[1] = Array.new

for i in (1...3)
  parametres = Hash.new

  # Les solucions
  parametres['x'] = rand(-10..10)
  parametres['y'] = rand(-10..10)
  
  # Els paràmetres del sistema
  parametres['a'] = rand(-10..10)
  parametres['c'] = parametres['a'] + rand(1..10)  
  
  ## M'assegur que ni 'a' ni 'c' són 0
  if parametres['a'] == 0
     parametres['a'] = 2
  end

  if parametres['c'] == 0
     parametres['c'] = 3
  end
  
  # Calculam b i d en funció de tot l'anterior
  parametres['b'] = parametres['y'] - parametres['a']*parametres['x']  
  parametres['d'] = parametres['y'] - parametres['c']*parametres['x']

  exercicis[1].push(parametres)
end
%>

\startexercici[reference=exercici-1, title={aïllats}] Resoleu els sistemes següents:
\startitemize[a,columns]
<% exercicis[1].each do |par| %>
\item \startformula \startmatrix[left={\left\{ \, }, right={\, \right. }, align={left}]
\NC y \NC = <%=par['a']%> x  <%=par['b'].to_ss%> \NR
\NC y \NC = <%=par['c']%> x  <%=par['d'].to_ss%> \NR
\stopmatrix \stopformula
<% end %>
\stopitemize
\stopexercici

<%# Exercici 2 %>
<%
exercicis[2] = Array.new

for i in (1...3)
  parametres = Hash.new

  # Les solucions
  parametres['x'] = rand(-10..10)
  parametres['y'] = rand(-10..10)

  # Els paràmetres del sistema
  delta = [1,-1]
  
  parametres['a'] = rand(2..10)
  ## b i d són -1 o 1
  parametres['b'] = delta[rand(0..1)]
  parametres['d'] = rand(2..10)
  parametres['e'] = delta[rand(0..1)]
  
  if parametres['a'] == parametres['d']
    parametres['d'] = parametres['a'] + 1
  end
  
  # Calculam c i f en funció de tot l'anterior
  parametres['c'] = parametres['a']*parametres['x']+parametres['b']*parametres['y']
  parametres['f'] = parametres['d']*parametres['x']+parametres['e']*parametres['y']

  exercicis[2].push(parametres)
end

%>


\startexercici[reference=exercici-2, title={tipus $\pm y$}] Resoleu els sistemes següents:
\startitemize[a, columns]
<% exercicis[2].each do |par| %>
\item \startformula \startmatrix[left={\left\{ \, }, right={\, \right. }, align={left}]
\NC <%=par['a']%> x <%=par['b'].to_ss%>y \NC = <%=par['c']%> \NR
\NC <%=par['d']%> x <%=par['e'].to_ss%>y \NC =  <%=par['f']%> \NR
\stopmatrix \stopformula
<% end %>
\stopitemize
\stopexercici


<%# Exercici 3 %>
<%
exercicis[3] = Array.new

for i in (1...3)
  parametres = Hash.new

  # Les solucions
  # M'assegur que les solucions són nombres sencers
  parametres['x'] = rand(-10..10)
  parametres['y'] = rand(-10..10)

  # Els paràmetres del sistema
  parametres['a'] = rand(2..10)
  parametres['b'] = rand(2..10)
  parametres['d'] = rand(2..10)
  parametres['e'] = rand(2..10)
  
  if parametres['a'] == parametres['d']
    parametres['d'] = parametres['a'] + 1
  end
  
  # Calculam c i f en funció de tot l'anterior
  parametres['c'] = parametres['a']*parametres['x']+parametres['b']*parametres['y']
  parametres['f'] = parametres['d']*parametres['x']-parametres['e']*parametres['y']

  exercicis[3].push(parametres)
end

%>


\startexercici[reference=exercici-3, title={estàndard}] Resoleu els sistemes següents:
\startitemize[a, columns]
<% exercicis[3].each do |par| %>
\item \startformula \startmatrix[left={\left\{ \, }, right={\, \right. }, align={left}]
\NC <%=par['a']%> x + <%=par['b']%>y \NC = <%=par['c']%> \NR
\NC <%=par['d']%> x - <%=par['e']%>y \NC =  <%=par['f']%> \NR
\stopmatrix \stopformula
<% end %>
\stopitemize
\stopexercici

\stopsubsubject

<%# ----------------------- Solucions ------------------------ %>
\page[yes]
\startsubsubject[title={Solucions}]

\startitemize
\sym{\in[exercici-1]}
\startitemize[a, text]
<% exercicis[1].each do |par| %>
\item $x = <%=par['x']%>$, $y = <%=par['y']%>$
<% end %>
\stopitemize

\sym{\in[exercici-2]}
\startitemize[a, text]
<% exercicis[2].each do |par| %>
\item $x = <%=par['x']%>$, $y = <%=par['y']%>$
<% end %>
\stopitemize

\sym{\in[exercici-3]}
\startitemize[a, text]
<% exercicis[3].each do |par| %>
\item $x = <%=par['x']%>$, $y = <%=par['y']%>$
<% end %>
\stopitemize


\stopitemize


\vfill
Les solucions d'aquests exercicis s'han calculat automàticament usant programari lliure: encara que totes les expressions són correctes, potser algunes es poden simplificar més.

\stopsubsubject

<%# ----------------------- Resolució ------------------------ %>
\page[yes]
\startsubsubject[title={Resolució}]

\startitemize
\sym{\in[exercici-1]}
\startitemize[a, text]
<% exercicis[1].each do |par| %>
<% a = par['a']
   b = par['b']
   c = par['c']
   d = par['d']
   x = par['x']
   y = par['y']
%>

\item Igualem les dues expressions de les $y$ i obtenim l'equació següent:
\startformula
<%=a%>x <%=b.to_ss%> = <%=c%>x  <%=d.to_ss%>,
\stopformula
que resolem:
\startformula \startalign
 \NC <%=a%>x <% if c > 0%> <%=(-c).to_ss%> <% else%> <%=(+c).to_ss%> <%end %>x \NC = <%=d.to_ss%> <% if b > 0%> <%=(-b).to_ss%> <% else%> <%=(+b).to_ss%> <%end %> \NR
 \NC <%=a -c%>x \NC = <%=d - b%> \NR
 \NC x \NC = \frac{<%=d - b%>}{<%=a -c%>} \NR
 \NC x \NC = <%=x%> \NR
\stopalign \stopformula

Ara procedim a substituir la $x$ en qualsevol de les dues expressions de les $y$. Ara bé, si ho feim en ambdues, llavors podem comprovar que tenim el sistema ben resolt quan els dos resultats coincideixen:

$y = <%=a%>\cdot (<%=x%>) + (<%=b%>) = <%= a*x %> + (<%=b%>) = <%=a * x + b%>$

$y = <%=c%>\cdot (<%=x%>) + (<%=d%>) = <%= c*x %> + (<%=d%>) = <%=c * x + d%>$

\medskip
Per tant, les solucions del sistema són $x = <%=x%>$ i $y = <%=y%>$.

<% end %>
\stopitemize

\sym{\in[exercici-2]}
\startitemize[a, text]
<% exercicis[2].each do |par| %>

\item En primer lloc, hem d'aïllar una de les incògnites, per exemple la $y$:
\startformula \startmatrix[left={\left\{ \, }, right={\, \right. }, align={left}]
\NC <%=par['a']%> x <%=par['b'].to_ss%>y \NC = <%=par['c']%> \NR
\NC <%=par['d']%> x <%=par['e'].to_ss%>y \NC =  <%=par['f']%> \NR
\stopmatrix
\Rightarrow
\startmatrix[left={\left\{ \, }, right={\, \right. }, align={left}]
\NC  <%=par['b']%>y \NC = <%=par['c']%> - <%=par['a']%> x \NR
\NC  <%=par['e']%>y \NC =  <%=par['f']%> - <%=par['d']%> x \NR
\stopmatrix
\Rightarrow
\startmatrix[left={\left\{ \, }, right={\, \right. }, align={left}]
\NC  y \NC = <%=par['c']/par['b']%> <%=(-par['a']/par['b']).to_ss%> x  \NR
\NC  y \NC =  <%=par['f']/par['e']%>  <%=(-par['d']/par['e']).to_ss%> x \NR
\stopmatrix
\stopformula
Igualem les darreres expressions de les $y$, obtenint una equació:
\startformula
<%=par['c']/par['b']%> <%=(-par['a']/par['b']).to_ss%> x  = <%=par['f']/par['e']%>  <%=(-par['d']/par['e']).to_ss%> x
\stopformula
que resolem tot seguit: $<%=par['c']/par['b']%> <%=(-par['a']/par['b']).to_ss%> x  = <%=par['f']/par['e']%>  <%=(-par['d']/par['e']).to_ss%> x$ $\Rightarrow$ $<%=(-par['a']/par['b']).to_ss%> x   <%=(par['d']/par['e']).to_ss%> x= <%=par['f']/par['e']%> <%=(-par['c']/par['b']).to_ss%>$ $\Rightarrow$  $<%=(-par['a']/par['b']) + (par['d']/par['e'])%> x  = <%=par['f']/par['e'] - par['c']/par['b']%>$ $\Rightarrow$ $x = <%=par['x']%>$.

Ara substituïm el valor de la $x$ a les expressions de la $y$:
\startformula
\startmatrix[left={\left\{ \, }, right={\, \right. }, align={left}]
\NC  y \NC = <%=par['c']/par['b']%> <%=(-par['a']/par['b']).to_ss%> \cdot (<%=par['x']%>)  \NR
\NC  y \NC =  <%=par['f']/par['e']%>  <%=(-par['d']/par['e']).to_ss%> \cdot (<%=par['x']%>) \NR
\stopmatrix
\Rightarrow
\startmatrix[left={\left\{ \, }, right={\, \right. }, align={left}]
\NC  y \NC = <%=par['c']/par['b']%> <%=(-par['a']/par['b'] * par['x']).to_ss%>  \NR
\NC  y \NC =  <%=par['f']/par['e']%>  <%=(-par['d']/par['e'] * par['x']).to_ss%> \NR
\stopmatrix
\Rightarrow
\startmatrix[left={\left\{ \, }, right={\, \right. }, align={left}]
\NC  y \NC = <%=par['y']%> \NR
\NC  y \NC =  <%=par['y']%>\NR
\stopmatrix
\stopformula
<% end %>
\stopitemize

\sym{\in[exercici-3]}
\startitemize[a, text]
<% exercicis[3].each do |par| %>
<%
solucio_x = Rational((-par['f']*par['b']-par['c']*par['e']), (-par['a']*par['e'] - par['d']*par['b']))
%>

\item En primer lloc, aïllem la $y$ a les dues equacions:
\startformula
\startmatrix[left={\left\{ \, }, right={\, \right. }, align={left}]
\NC <%=par['a']%> x + <%=par['b']%>y \NC = <%=par['c']%> \NR
\NC <%=par['d']%> x - <%=par['e']%>y \NC =  <%=par['f']%> \NR
\stopmatrix

\Rightarrow

\startmatrix[left={\left\{ \, }, right={\, \right. }, align={left}]
\NC  <%=par['b']%>y \NC = <%=par['c']%> - <%=par['a']%> x \NR
\NC - <%=par['e']%>y \NC =  <%=par['f']%> - <%=par['d']%> x \NR
\stopmatrix

\Rightarrow

\startmatrix[left={\left\{ \, }, right={\, \right. }, align={left}]
\NC  y \NC = \frac{<%=par['c']%>}{<%=par['b']%>} - \frac{<%=par['a']%> x}{<%=par['b']%>} \NR
\NC y \NC =  -\frac{<%=par['f']%>}{<%=par['e']%>} + \frac{<%=par['d']%> x}{<%=par['e']%>} \NR
\stopmatrix
\stopformula
Per tant, 
$y = \frac{<%=par['c']%>}{<%=par['b']%>} - \frac{<%=par['a']%> x}{<%=par['b']%>}$ i  $y =  -\frac{<%=par['f']%>}{<%=par['e']%>} + \frac{<%=par['d']%> x}{<%=par['e']%>}$. Ara igualem les expressions i obtenim una equació:
\startformula
\frac{<%=par['c']%>}{<%=par['b']%>} - \frac{<%=par['a']%> x}{<%=par['b']%>} = -\frac{<%=par['f']%>}{<%=par['e']%>} + \frac{<%=par['d']%> x}{<%=par['e']%>}
\stopformula
Resolem aquesta equació:
$\frac{<%=par['c']%>}{<%=par['b']%>} - \frac{<%=par['a']%> x}{<%=par['b']%>}  = -\frac{<%=par['f']%>}{<%=par['e']%>} + \frac{<%=par['d']%> x}{<%=par['e']%>}$ $\Rightarrow$ $<%=par['c']*par['e']%> <%=-(par['a']*par['e']).to_ss%> x  = <%=(-par['f']*par['b']).to_ss%>  <%=(par['d']*par['b']).to_ss%> x$ $\Rightarrow$ $<%=(-par['a']*par['e'] - par['d']*par['b'])%> x  = <%=(-par['f']*par['b']-par['c']*par['e'])%>$ $\Rightarrow$ $x  = \frac{<%=(-par['f']*par['b']-par['c']*par['e'])%>}{<%=(-par['a']*par['e'] - par['d']*par['b'])%>}$ $\Rightarrow$ $x  = \frac{<%=solucio_x.numerator%>}{<%=solucio_x.denominator%>} = <%=par['x']%>$.

Posteriorment substituïm la $x$ en les expressions de les $y$:
\startformula
\startmatrix[left={\left\{ \, }, right={\, \right. }, align={left}]
\NC y \NC = \frac{<%=par['c']%>}{<%=par['b']%>} - \frac{<%=par['a']%> \cdot (<%=par['x']%>)}{<%=par['b']%>} \NR
\NC y  \NC = -\frac{<%=par['f']%>}{<%=par['e']%>} + \frac{<%=par['d']%> \cdot (<%=par['x']%>)}{<%=par['e']%>} \NR
\stopmatrix
\Rightarrow
\startmatrix[left={\left\{ \, }, right={\, \right. }, align={left}]
\NC y \NC = \frac{<%=par['c']%>}{<%=par['b']%>} - \frac{<%=par['a'] * par['x']%>}{<%=par['b']%>} \NR
\NC y  \NC = -\frac{<%=par['f']%>}{<%=par['e']%>} + \frac{<%=par['d'] * par['x']%>}{<%=par['e']%>} \NR
\stopmatrix
\Rightarrow
\startmatrix[left={\left\{ \, }, right={\, \right. }, align={left}]
\NC y \NC = \frac{<%=par['c'] - (par['a'] * par['x'])%>}{<%=par['b']%>} \NR
\NC y  \NC = \frac{<%=-par['f'] + (par['d'] * par['x'])%>}{<%=par['e']%>} \NR
\stopmatrix
\stopformula
Per tant, $y = <%=par['y']%>$.
<% end %>
\stopitemize


\stopitemize

\vfill
La resolució d'aquests exercicis s'ha calculat automàticament usant programari lliure: encara que totes les expressions són correctes, potser algunes es poden simplificar més.

\stopsubsubject

\stopsubject

\stoptext
